/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingRutaDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.PricingRutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * 
 * @author Rafius
 */
@Service("pricingRutaService")
public class PricingRutaServiceImpl implements PricingRutaService {

	@Autowired
	private PricingRutaDAO pricingRutaDAO;

	public List<PricingRuta> obtenerTodos() {
		return pricingRutaDAO.obtenerTodos();
	}

	public PricingRuta obtenerID(Integer id) {
		return pricingRutaDAO.obtenerID(id);
	}

	@Transactional
	public PricingRuta suscribir(PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingRutaDAO.suscribir(entidad);
	}

	@Transactional
	public PricingRuta actualizacion(PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.ATIVO);

		return pricingRutaDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(PricingRuta entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Pricing.EXCLUIDO);

		pricingRutaDAO.actualizacion(entidad);
	}

	public Boolean obtenerPricingRuta(Pricing pricing, Ruta ruta) {
		return pricingRutaDAO.obtenerPricingRuta(pricing, ruta);
	}

	@Override
	@Transactional
	public void borrar(List<PricingRuta> pricingRutas) {
		if(pricingRutas != null && !pricingRutas.isEmpty()) {
			for (PricingRuta pricingRuta : pricingRutas) {
				borrar(pricingRuta);
			}
		}
	}
}
